datablock AudioProfile(EgonRifle_hitSound)
{
   filename    = "./sound/hit1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(EgonRifle_ProjectileLoopSound)
{
   filename    = "./sound/low2.wav";
   description = AudioClosestLooping3d;
   preload = true;
};


// I would've loved to use a looping fire effect	 
// but I don't think this is possible in Blockland.  
//
datablock AudioProfile(EgonRifle_openSound)		 
{													 
  filename    = "./sound/fire_open_mono.wav";				 
  description = AudioCloseLooping3d;				 
  preload = true;									 
};												 
//


datablock AudioProfile(EgonRifle_singleShotSound)
{
   filename    = "./sound/fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(EgonRifle_ventSound)
{
   filename    = "./sound/vent.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(EgonRifle_Projectile_ExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 000;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.1 0.1 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 1.25;
	sizes[1]      = 0.75;

	useInvAlpha = false;
};
datablock ParticleEmitterData(EgonRifle_Projectile_ExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "EgonRifle_Projectile_ExplosionParticle";

   useEmitterColors = true;
   uiName = "Gluon Gun Hit Dust";
};


datablock ParticleData(EgonRifle_Projectile_ExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 0.5 1.0 0.9";
	colors[1]     = "1.0 1.0 1.0 0.0";
	sizes[0]      = 1.3;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(EgonRifle_Projectile_ExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 30;
   velocityVariance = 30;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "EgonRifle_Projectile_ExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Gluon Gun Hit Flash";
};

datablock ExplosionData(EgonRifle_RecoilExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
  camShakeFreq = "2 2 2";
  camShakeAmp = "0.1 0.1 0.1";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

datablock ExplosionData(EgonRifle_Projectile_Explosion)
{
   //explosionShape = "";
	soundProfile = EgonRifle_hitSound;

   lifeTimeMS = 150;

   particleEmitter = EgonRifle_Projectile_ExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = EgonRifle_Projectile_ExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 2;
   lightStartColor = "0.0 0.6 0.6";
   lightEndColor = "0 0 0";
};

datablock ItemData(EgonRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shape/gluon_draft_9.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Gluon Gun";
	iconName = "./image/weaponGluonIcon";
	doColorShift = true;
	colorShiftColor = (180/255) SPC (180/255) SPC (180/255) SPC (255/255);

	 // Dynamic properties defined by the scripts
	image = EgonRifleImage;
	canDrop = true;
};

datablock ParticleData(EgonRifle_SmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.1 0.3 0.8 0.3";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 1.5;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};
datablock ParticleEmitterData(EgonRifle_SmokeEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 8.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "EgonRifle_SmokeParticle";

   uiName = "Gluon Gun Smoke";
};

AddDamageType("Egon",   '<bitmap:Add-Ons/Weapon_GluonTau/image/ci_Gluon> %1',    '%2 <bitmap:Add-Ons/Weapon_GluonTau/image/ci_Gluon> %1',1,1);

datablock ProjectileData(EgonRifle_RecoilProjectile)
{
	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= EgonRifle_RecoilExplosion;

};

datablock ProjectileData(EgonRifle_Projectile)
{
   //projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 12;
   directDamageType    = $DamageType::Egon;
   radiusDamageType    = $DamageType::Egon;
   
   sound = EgonRifle_ProjectileLoopSound;

   brickExplosionRadius = 0.25;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 175;
   verticalImpulse	  = 1;
   explosion           = EgonRifle_Projectile_Explosion;
   //particleEmitter     = EgonRifle_TrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 1000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;
   
	explodeondeath						= false;
	
   hasLight    = false;
   lightRadius = 4.0;
   lightColor  = "0 0.6 0.6";

   uiName = "Gluon Gun Projectile";
};

datablock ShapeBaseImageData(EgonRifleImage)
{
   // Basic Item properties
   shapeFile = "./shape/gluon_draft_9.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = 0;
   eyeOffset = "0.3 0.7 -2";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = EgonRifle_Projectile;
   projectileType = Projectile;

	casing = "";
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   LarmReady = true;

   doColorShift = true;
   colorShiftColor = EgonRifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]					= weaponSwitchSound;
	stateSequence[0]				= "Ready";
	
	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Spinup";
	stateScript[1]                  = "onStopFire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]				= "Ready";

	// warning square come forward?
	stateName[2]                    = "Spinup";
	stateAllowImageChange[2]        = false;
	stateTransitionOnTimeout[2]     = "Fire";
	stateScript[2]                  = "onSpinup";
	stateTimeoutValue[2]            = 0.25;
	stateWaitForTimeout[2]			= true;
	//stateSound[2]					= EgonRifle_singleShotSound;
	stateSequence[2]				= "Charge";
	stateTransitionOnTriggerUp[2]   = "Ready";
	//stateSequenceOnTimeout[2]	= "Spin";
	
	
	
	// should probably do meter sequence here
	// warning square come forward?
	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.0125;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	//stateEmitter[3]					= EgonRifle_FlashEmitter;
	//stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= "";
	stateEjectShell[3]       		= true;

	
	// caution tri?
	stateName[4] 					= "Smoke";
	stateEmitter[4]					= EgonRifle_SmokeEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0.0;
	stateTransitionOnTimeout[4]     = "Check";

	stateName[5]					= "Check";
	stateTransitionOnTriggerUp[5]   = "Slow";
	stateTransitionOnTriggerDown[5] = "Fire";
	
	stateName[6]					= "Slow";
	stateTransitionOnTriggerDown[6] = "Fire";
	//stateSequence[6]                = "ready";
	stateEmitter[6]					= EgonRifle_SmokeEmitter;
	stateEmitterTime[6]				= 0.00;
	stateEmitterNode[6]				= "muzzleNode";
	stateAllowImageChange[6]        = false;
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.00;
	stateWaitForTimeout[6]			= true;

};

datablock StaticShapeData(GluonBeamStatic) 
{ 
	shapeFile = "./shape/laser.dts"; 
};

function Normal2Rotation(%normal)  
{  
	if(getWord(%normal, 2) == 1 || getWord(%normal, 2) == -1)
	{	
		%rotAxis = vectorNormalize(vectorCross(%normal, "0 1 0"));
	}
	else
	{
		%rotAxis = vectorNormalize(vectorCross(%normal, "0 0 1"));
	}

	%initialAngle = mACos(vectorDot(%normal, "0 0 1"));
	%rotation = %rotAxis SPC mRadtoDeg(%initialAngle);
	
	return %rotation;  
}

function EgonRifleImage::onFire(%this, %obj)
{
	if(getSimTime() - %obj.lastGluonTime < $Pref::GluonGun_Speed)
		return;
	
	%player = %obj;
	%client = %player.client;
	
	%muzzlePosition = %obj.getMuzzlePoint(0);
	%muzzleVector = %obj.getMuzzleVector(0);

	%client = %player.client;
	%start = %muzzlePosition;
	%end = vectorScale(%muzzleVector, 196);
	%mask = $TypeMasks::PlayerObjectType | 
			$TypeMasks::VehicleObjectType | 
			$TypeMasks::fxBrickObjectType | 
			$TypeMasks::StaticObjectType | 
			$TypeMasks::InteriorObjectType | 
			$TypeMasks::TerrainObjectType | 
			$TypeMasks::ForceFieldObjectType;
	
	%target = containerRayCast(%start, vectorAdd(%start, %end), %mask, %player);
	
	if(%target)
	{
		%pos1 = getWords(%target, 1, 3);
		%length = vectorDist(%start, %pos1);
		
		%hit = getWord(%target, 0);
		
		if(%hit.getType() & $TypeMasks::PlayerObjectType || %hit.getType() & $TypeMasks::VehicleObjectType)
		{
			if(miniGameCanDamage(%hit, %obj) == 1)
			{
				%hit.damage(%obj, %pos1, 10, $DamageType::Egon);
			}
		}
	}
	else
	{
		%length = 196;
		%pos1 = vectorAdd(%start, %end);
	}
	
	%obj.playAudio(0, EgonRifle_openSound);
	
	%rotation = Normal2Rotation(%muzzleVector);
	%transformRot = setWord(%rotation, 3, mDegtoRad(getWord(%rotation, 3)));
	
	%obj.spawnExplosion(EgonRifle_RecoilProjectile,"1 1 1");
	
	if(!isObject(%player.currentGluonLaser))
	{
		%laser = new StaticShape()
		{
			datablock = GluonBeamStatic;
			position = %muzzlePosition;  
			rotation = %rotation;  
		};
		%laser.setScale("4 4" SPC %length);
		%laser.setNodeColor("ALL", "0 1 1 1");
		%laser.schedule(5000, delete);
		MissionCleanup.add(%laser);
		
		%player.currentGluonLaser = %laser;
	}
	else
	{
		%player.currentGluonLaser.setScale("4 4" SPC %length);
		%player.currentGluonLaser.setTransform(%muzzlePosition SPC %transformRot);
	}
		
	if(getSimTime() - %obj.lastGluonTime < 100)
		return;
		
	%obj.lastGluonTime = getSimTime();
	
	%proj = new Projectile()
	{
		dataBlock = EgonRifle_Projectile;
		initialPosition = vectorAdd(%muzzlePosition, vectorScale(%muzzleVector, %length));
		initialVelocity = %muzzleVector;
	};
	%proj.explode();
	MissionCleanup.add(%proj);
	
}

function EgonRifleImage::onSpinup(%this,%obj)
{
	%obj.playAudio(0, EgonRifle_singleShotSound);
	%obj.spawnExplosion(EgonRifle_FirstRecoilProjectile,"3 3 3");
}

function EgonRifleImage::onStopFire(%this,%obj)
{
	%obj.stopAudio(0);
	%obj.playAudio(0,EgonRifle_ventSound);
	
	if(isObject(%obj.currentGluonLaser))
		%obj.currentGluonLaser.delete();
}

function EgonRifleImage::onUnmount(%this, %player)
{
	Parent::onUnmount(%this, %player);
	%player.stopAudio(0);
	if(isObject(%player.currentGluonLaser))
		%player.currentGluonLaser.delete();
}