datablock AudioProfile(TauCannon_Shot1Sound)
{
   filename    = "./sounds/single01.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TauCannon_ChargedShotSound)
{
   filename    = "./sounds/single_overcharged01.wav";
   description = AudioClose3d;
   preload = true;
};

// should this be a loop sound?
datablock AudioProfile(TauCannon_SpinUp)
{
   filename    = "./sounds/gauss_spinup.wav";
   description = AudioCloseLooping3d;
   preload = true;
};


/// why doesn't this work?
datablock AudioProfile(TauCannon_SpinSound)		 
{													 
  filename    = "./sounds/spinloop.wav";				 
  description = AudioCloseLooping3d;				 
  preload = true;									 
};	

datablock AudioProfile(TauCannon_OverchargeWarning)		 
{													 
  filename    = "./sounds/gauss_overcharging.wav";				 
  description = AudioCloseLooping3d;				 
  preload = true;									 
};					

datablock AudioProfile(TauCannon_charged)
{
   filename    = "./sounds/gauss_charged.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TauCannon_OverchargeSound)
{
   filename    = "./sounds/gauss_overcharged.wav";
   description = AudioClose3d;
   preload = true;
};


// stopAudio wont work in some areas... this does. waste of a datablock, will look into
//datablock AudioProfile(TauCannon_NullSound)
//{
//   filename    = "";
//   description = AudioClose3d;
//   preload = true;
//};

datablock ParticleData(TauCannon_Projectile_ExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 000;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.7 0.2 0.3";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 1.25;
	sizes[1]      = 0.75;

	useInvAlpha = false;
};
datablock ParticleEmitterData(TauCannon_Projectile_ExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TauCannon_Projectile_ExplosionParticle";

   useEmitterColors = true;
   uiName = "Tau Cannon Hit Dust";
};


datablock ParticleData(TauCannon_Projectile_ExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 125;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.9 0.0 0.9";
	colors[1]     = "1.0 1.0 1.0 0.0";
	sizes[0]      = 1.3;
	sizes[1]      = 0.2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(TauCannon_Projectile_ExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 30;
   velocityVariance = 30;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TauCannon_Projectile_ExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Tau Cannon Hit Flash";
};

datablock ExplosionData(TauCannon_Projectile_Explosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 150;

   particleEmitter = TauCannon_Projectile_ExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = TauCannon_Projectile_ExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 2;
   lightStartColor = "0.6 0.6 0.2";
   lightEndColor = "0 0 0";
};


///////////// alt explosion

datablock ParticleData(TauCannon_Projectile_AltExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 000;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.2 0.2 0.9 0.3";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 3.25;
	sizes[1]      = 10.75;

	useInvAlpha = false;
};
datablock ParticleEmitterData(TauCannon_Projectile_AltExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TauCannon_Projectile_AltExplosionParticle";

   useEmitterColors = true;
   uiName = "Tau Cannon Hit Dust";
};


datablock ParticleData(TauCannon_Projectile_AltExplosionRingParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = -5.5;
	inheritedVelFactor   = 5.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 125;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.2 0.0 0.9";
	colors[1]     = "0.0 0.0 1.0 0.0";
	sizes[0]      = 2.3;
	sizes[1]      = 1.2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(TauCannon_Projectile_AltExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 30;
   velocityVariance = 30;
   ejectionOffset   = 0.0;
   thetaMin         = 50;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TauCannon_Projectile_AltExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Tau Cannon Hit Flash";
};


datablock ExplosionData(TauCannon_Projectile_AltExplosion)
{
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
	soundProfile = "";

   lifeTimeMS = 150;

   particleEmitter = TauCannon_Projectile_AltExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = TauCannon_Projectile_AltExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 2;
   lightStartColor = "0.6 0.6 0.2";
   lightEndColor = "0 0 0";
   
   damageRadius = 3;
   radiusDamage = 100;

   impulseRadius = 6;
   impulseForce = 1000;
};

datablock ItemData(TauCannon_Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shape/TauCannon2_1.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Tau Cannon";
	iconName = "./image/weaponIcon";
	doColorShift = true;
	colorShiftColor = (110/255) SPC (115/255) SPC (110/255) SPC (255/255);

	 // Dynamic properties defined by the scripts
	image = TauCannon_Image;
	canDrop = true;
};

datablock ParticleData(TauCannon_FlashParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 1.0 0.3 0.6";
	colors[1]     = "1.0 0.7 1.0 0.0";
	sizes[0]      = 1.8;
	sizes[1]      = 0.0;


	useInvAlpha = false;
};
datablock ParticleEmitterData(TauCannon_FlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 120.0;
   velocityVariance = 60.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TauCannon_FlashParticle";

   uiName = "Tau Cannon MuzzleFlash";
};

// ALT FIRE

datablock ParticleData(TauCannon_HugeFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.3 0.9 0.6";
	colors[1]     = "1.0 1.0 1.0 0.0";
	sizes[0]      = 3.8;
	sizes[1]      = 0.0;
	times[0]      = 0.0;
	times[1]	  = 0.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(TauCannon_HugeFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 60.0;
   velocityVariance = 59.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 30;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TauCannon_HugeFlashParticle";

   uiName = "Tau Cannon Huge MuzzleFlash";
};

// COOL OFF

datablock ParticleData(TauCannon_CoolDownParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 250;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.3 0.0 0.6";
	colors[1]     = "1.0 1.0 1.0 0.0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(TauCannon_CoolDownEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TauCannon_CoolDownParticle";

   uiName = "Tau Cannon Cooldown";
};

///////////// Muzzlesmoke

datablock ParticleData(TauCannon_SmokeParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 250;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.6";
	colors[1]     = "0.7 0.4 0.0 0.0";
	sizes[0]      = 0.9;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(TauCannon_SmokeEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 12.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TauCannon_SmokeParticle";

   uiName = "Tau Cannon Smoke";
};

AddDamageType("TauCannon",   '<bitmap:Add-Ons/Weapon_GluonTau/image/ci_TauCannon> %1',    '%2 <bitmap:Add-Ons/Weapon_GluonTau/image/ci_TauCannon> %1',1,1);
AddDamageType("TauCannonAlt",   '<bitmap:Add-Ons/Weapon_GluonTau/image/ci_TauCannonRadius> %1',    '%2 <bitmap:Add-Ons/Weapon_GluonTau/image/ci_TauCannonRadius> %1',1,0);

datablock ProjectileData(TauCannon_Projectile)
{
   //projectileShapeName = "Add-Ons/Weapon_TauCannon_/bullet.dts";
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::TauCannon;
   radiusDamageType    = $DamageType::TauCannon;
   
   sound = "";

   brickExplosionRadius = 0.25;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 2500;
   verticalImpulse	  = 50;
   explosion           = TauCannon_Projectile_Explosion;
   //particleEmitter     = TauCannon_TrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 100;
   lifetime            = 1000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.6;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.0;
   
	explodeondeath						= false;
	
   hasLight    = false;
   lightRadius = 4.0;
   lightColor  = "0 0.6 0.6";

   uiName = "Tau Cannon Projectile";
};

datablock ProjectileData(TauCannon_AltProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 400;
   directDamageType    = $DamageType::TauCannonAlt;
   radiusDamageType    = $DamageType::TauCannonAlt;
   
   sound = "";

   brickExplosionRadius = 1;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;             
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 2500;
   verticalImpulse	  = 50;
   explosion           = TauCannon_Projectile_AltExplosion;
   //particleEmitter     = TauCannon_AltTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.5;
   isBallistic         = false;
   gravityMod = 0.0;
   
	explodeondeath						= true;
	
   hasLight    = false;
   lightRadius = 4.0;
   lightColor  = "0 0.6 0.6";

   uiName = "Tau Cannon Alt Projectile";
};

datablock ExplosionData(TauCannon_RecoilExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
  camShakeFreq = "2 2 2";
  camShakeAmp = "0.7 0.7 0.7";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

datablock ProjectileData(TauCannon_RecoilProjectile)
{
	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= TauCannon_RecoilExplosion;

};

datablock ShapeBaseImageData(TauCannon_Image)
{
   // Basic Item properties
	shapeFile = "./shape/TauCannon2_1.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "1 2 -1.9";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = TauCannon_Item;
   ammo = " ";
   projectile = TauCannon_Projectile;
   projectileType = Projectile;

	casing = "";
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = TauCannon_Item.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
// Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]      = "Ready";
	stateScript[0]                   = "onStopFire";
	stateSound[0]					 = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateTransitionOnNotLoaded[1]   = "Charging";
	stateAllowImageChange[1]         = true;
	stateSequence[1]				 = "Ready";

// ---------------- FIRE
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateSpinThread[2]				= Stop;
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= TauCannon_FlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= TauCannon_Shot1Sound;
	stateEjectShell[2]       	    = true;

	stateName[3] 					= "Smoke";
	stateEmitter[3]					= TauCannon_SmokeEmitter;
//	stateSound[3]					= TauCannon_ReloadSound;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.0;
	stateSequence[3]                = "Reload";
	stateTransitionOnTimeout[3]     = "ready";

	stateName[4]					  = "Reload";
	stateSequence[4]                  = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	
	
// ----------- CHARGING
	stateName[5]                    = "Charging";
	stateSpinThread[5]				= SpinUp;
	stateTransitionOnTimeout[5]     = "Charged";
    stateTransitionOnLoaded[5]   	= "Fire";
	stateTimeoutValue[5]            = 3;
	stateAllowImageChange[5]        = false;
	stateSequence[5]                = "SpinShort";
	stateScript[5]                  = "onCharge";
	stateWaitForTimeout[5]			= false;
	
	
// --------- CHARGED
	stateName[6]                    = "Charged";
	stateSound[6]					= TauCannon_charged;
	stateTransitionOnLoaded[6]   	= "FireCharged";
    //stateTransitionOnTriggerUp[6]   = "FireCharged";
	stateAllowImageChange[6]        = false;
	stateTimeoutValue[6]            = 7;
	stateTransitionOnTimeout[6]     = "Overcharging";
	stateSequence[6]                = "SpinLong";
	stateSpinThread[6]				= FullSpeed;
	stateScript[6]                  = "onCharged";
	stateWaitForTimeout[6]			= false;
	
// ------ FIRE CHARGED SHOT
	
	stateName[7]                    = "FireCharged";
	stateTransitionOnTimeout[7]     = "Smoke";
	stateTimeoutValue[7]            = 1.2;
	stateFire[7]                    = true;
	stateAllowImageChange[7]        = false;
//	stateSequence[7]                = "SpinLong";'
	stateSequence[7]                = "SpinShort";
	stateSpinThread[7]				= Stop;
	stateScript[7]                  = "onFireCharged";
	stateWaitForTimeout[7]			= true;
	stateEmitter[7]					= TauCannon_HugeFlashEmitter;
	stateEmitterTime[7]				= 0.05;
	stateEmitterNode[7]				= "muzzleNode";
	stateSound[7]					= TauCannon_ChargedShotSound;
	stateEjectShell[7]       		= true;
	
// -------- OVERCHARGE WARNING
	
	stateName[8]                    = "Overcharging";
    stateTransitionOnLoaded[8]   	= "FireCharged";
	stateAllowImageChange[8]        = false;
	stateTimeoutValue[8]            = 3;
	stateTransitionOnTimeout[8]     = "Overcharged";
	stateSequence[8]                = "SpinShort";
	stateScript[8]                  = "onBeginOvercharge";
	stateWaitForTimeout[8]			= false;
	
// --------- OVERCHARGED EXPLOSION
	
	stateName[9]					= "Overcharged";
	stateSequence[9] 				= "Fire";
	stateSound[9]					= TauCannon_OverchargeSound;
	stateSpinThread[9]				= Stop;
	stateScript[9]					= "onOvercharged";
	stateTransitionOnTimeout[9]     = "OverchargedCooldown";
	stateTimeoutValue[9]            = 0.01;
	
// ---------- COOL DOWN
	stateName[10]					= "OverchargedCooldown";
	stateSequence[10] 				= "Fire";
	stateEmitter[10]				= TauCannon_CoolDownEmitter;
	stateEmitterTime[10]			= 5;
	stateEmitterNode[10]			= "muzzleNode";
	stateTransitionOnTimeout[10]    = "Smoke";
	stateTimeoutValue[10]           = 5;
	
};

datablock StaticShapeData(TauBeamStatic) 
{ 
	shapeFile = "./shape/laser.dts"; 
};

package TauCannon
{
	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		if(%player.getMountedImage(0) $= TauCannon_Image.getID() && %slot $= 4)
		{
			if(!%val)
			{
				%player.setImageLoaded(0, 1);
			}
			else
			{
				%player.setImageLoaded(0, 0);
			}
		}
		return Parent::onTrigger(%this, %player, %slot, %val);
	}

};
activatePackage(TauCannon);

function TauCannon_Image::onMount(%this,%obj,%slot)
{
	%obj.setImageLoaded(0, 1);
}

function TauCannon_Image::onFirecharged(%this,%obj,%slot)
{

	%player = %obj;
	
	%player.playThread(2, jump);

	// Stop charge loop and warning loop
	%obj.stopAudio(3);
	%obj.stopAudio(1);
	%obj.spawnExplosion(TauCannon_RecoilProjectile,"3 3 3");
	
	%muzzlePosition = %obj.getMuzzlePoint(0);
	%muzzleVector = %obj.getMuzzleVector(0);
	%beamPosition = doSuperTauBeam(%muzzleVector, %muzzlePosition, %player);
	%beamPosition = doSuperTauBeam(%muzzleVector, %beamPosition, %player);
	%beamPosition = doSuperTauBeam(%muzzleVector, %beamPosition, %player);
	%beamPosition = doSuperTauBeam(%muzzleVector, %beamPosition, %player);
	
	// Blowback
	%recVel = vectorScale(vectorScale(%muzzleVector, -1), 10);
	%player.addVelocity(%recVel);

}


function TauCannon_Image::onCharge(%this,%obj,%slot)
{
	%obj.playAudio(3, TauCannon_SpinUp);
}


function TauCannon_Image::onCharged(%this,%obj,%slot)
{
	%obj.playAudio(3, TauCannon_SpinSound);
	%obj.playThread(2, shiftRight);
}


function TauCannon_Image::onBeginOvercharge(%this,%obj,%slot)
{
	%obj.playAudio(1, TauCannon_OverchargeWarning);
}

function TauCannon_Image::onOvercharged(%this,%obj,%slot)
{

	%obj.spawnExplosion(TauCannon_RecoilProjectile,"5 5 5");
	%obj.spawnExplosion(TauCannon_AltProjectile,"1 1 1");
	
	%obj.stopAudio(3);
	%obj.stopAudio(1);
	
	%obj.playThread(2, shiftAway);
}

function TauCannon_Image::onFire(%this,%obj)
{
	%player = %obj;
	%client = %player.client;
	
	%obj.spawnExplosion(TauCannon_RecoilProjectile,"1 1 1");
	%obj.stopAudio(3);
	
	%muzzlePosition = %obj.getMuzzlePoint(0);
	%muzzleVector = %obj.getMuzzleVector(0);
	
	// first beam
	
	
	%beam = doTauReflectionBeam(%muzzleVector, 0, %muzzlePosition, %player, 1);
	
	%reflect = getWord(%beam, 0);
	%vector = getWords(%beam, 1, 3);
	%normal = getWords(%beam, 4, 6);
	%position = getWords(%beam, 7, 9);
	
	if(!%reflect)
		return;
	
	%beam = doTauReflectionBeam(%vector, %normal, %position, %player, 2);
	
	%reflect = getWord(%beam, 0);
	%vector = getWords(%beam, 1, 3);
	%normal = getWords(%beam, 4, 6);
	%position = getWords(%beam, 7, 9);
	
	if(!%reflect)
		return;
	
	%beam = doTauReflectionBeam(%vector, %normal, %position, %player, 3);
	
	%reflect = getWord(%beam, 0);
	%vector = getWords(%beam, 1, 3);
	%normal = getWords(%beam, 4, 6);
	%position = getWords(%beam, 7, 9);
	
	if(!%reflect)
		return;
	
}

function TauCannon_Projectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	%proj = new Projectile()
	{
		dataBlock = TauCannon_Projectile;
		initialPosition = %obj.getPosition();
		initialVelocity = vectorScale(%vec,1);
		client = %col.client;
	};
	MissionCleanup.add(%proj);
	%proj.explode();
	

   Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
}


function doTauReflectionBeam(%vector, %normal, %position, %obj, %number)
{
	%client = %obj.client;
	%v = %vector;
	%n = %normal;
	
	%reflectPos = %position;
	%reflectVec = getBounceVector(%v, %n);
	
	%dot = vectorDot(%v, %reflectVec);
	%dot = %dot / (vectorLen(%v) * vectorLen(%reflectVec));
	%acos = mACos(%dot);
	%angle = 180 - mRadtoDeg(%acos);
	if(%angle < 90)
	{
		return;
	}
	%start = %reflectPos;
	%end = vectorScale(%reflectVec, 64);
	%mask = $TypeMasks::PlayerObjectType | 
		$TypeMasks::VehicleObjectType | 
		$TypeMasks::fxBrickObjectType | 
		$TypeMasks::StaticObjectType | 
		$TypeMasks::InteriorObjectType | 
		$TypeMasks::TerrainObjectType | 
		$TypeMasks::ForceFieldObjectType;
	
	%target = containerRayCast(%start, vectorAdd(%start, %end), %mask);
	
	%length = 64;
	%pos1 = vectorAdd(%start, %end);
	if(%target)
	{
		%reflect = true;
		%pos1 = getWords(%target, 1, 3);
		%length = vectorDist(%start, %pos1);
		%normal = getWords(%target, 4, 6);
		
		%hit = getWord(%target, 0);
		
		if(%hit.getType() & $TypeMasks::PlayerObjectType || %hit.getType() & $TypeMasks::VehicleObjectType)
		{
			if(miniGameCanDamage(%hit, %obj) == 1)
				%hit.damage(%obj, %pos1, 45, $DamageType::TauCannon);
			%reflect = false;
		}
	}
	
	%laser = new StaticShape()
	{
		datablock = TauBeamStatic;
		position = %reflectPos;  
		rotation = Normal2Rotation(%reflectVec);  
	};
	%laser.setScale("3 3" SPC %length);
	%laser.setNodeColor("ALL", "1 1 0 1");
	%laser.schedule(66, delete);
	MissionCleanup.add(%laser);
	
	%proj = new Projectile()
	{
		dataBlock = TauCannon_Projectile;
		initialPosition = %pos1;
		initialVelocity = %end;
		scale = 1.25 SPC 1.25 SPC 1.25;
		client = %client;
	};
	%proj.explode();
	MissionCleanup.add(%proj);

	return %reflect SPC %reflectVec SPC %normal SPC %pos1;
}

function doSuperTauBeam(%vector, %position, %obj)
{
	%client = %obj.client;
	%start = %position;
	%end = vectorScale(%vector, 64);
	%mask = $TypeMasks::PlayerObjectType | 
		$TypeMasks::VehicleObjectType | 
		$TypeMasks::fxBrickObjectType | 
		$TypeMasks::StaticObjectType | 
		$TypeMasks::InteriorObjectType | 
		$TypeMasks::TerrainObjectType | 
		$TypeMasks::ForceFieldObjectType;
	
	%target = containerRayCast(%start, vectorAdd(%start, %end), %mask);
	
	%length = 64;
	%pos1 = vectorAdd(%start, %end);
	if(%target)
	{
		%pos1 = getWords(%target, 1, 3);
		%length = vectorDist(%start, %pos1);
		%normal = getWords(%target, 4, 6);
		
		%hit = getWord(%target, 0);
		
		if(%hit.getType() & $TypeMasks::PlayerObjectType || %hit.getType() & $TypeMasks::VehicleObjectType)
		{
			if(miniGameCanDamage(%hit, %obj) == 1)
				%hit.damage(%obj, %pos1, 200, $DamageType::TauCannonAlt);
			%reflect = false;
		}
	}
	
	%laser = new StaticShape()
	{
		datablock = TauBeamStatic;
		position = %position;  
		rotation = Normal2Rotation(%vector);  
	};
	%laser.setScale("6 6" SPC %length);
	%laser.setNodeColor("ALL", "0 1 1 1");
	%laser.schedule(66, delete);
	MissionCleanup.add(%laser);
	
	%proj = new Projectile()
	{
		dataBlock = TauCannon_AltProjectile;
		initialPosition = %pos1;
		initialVelocity = %vector;
		client = %client;
	};
	%proj.explode();
	MissionCleanup.add(%proj);

	return %pos1;
}


function getBounceVector(%vector, %normal)
{
	%v = %vector;
	%n = %normal;
	
	//%reflectVec = vectorAdd(vectorCross(vectorCross(vectorDot(%v, %n), %n), -2), %v);
	return vectorSub(%v, vectorScale(%n, 2 * vectorDot(%v, %n)));
}

function TauCannon_Image::onStopFire(%this,%obj)
{
	%obj.setImageLoaded(0, 0);
}






// exec("./DB_Audio.cs");  
// exec("./DB_ExplosionParticle.cs");  
// exec("./DB_Item.cs");  
// exec("./DB_MuzzleFlashParticle.cs");  
// exec("./DB_MuzzleSmokeParticle.cs");  
// exec("./DB_Particle_BulletTrail.cs");  
// exec("./DB_Projectiles.cs");  
// exec("./DB_recoil.cs");
// exec("./DB_Weapon.cs");
// exec("./Functions.cs"); 